﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Encodings.IntegerVectorEncoding;

namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
  public static class GQAPIntegerVectorProximityCalculator {
    public static double CalculateGenotypeSimilarity(IntegerVector a, IntegerVector b) {
      int similar = 0;
      for (int i = 0; i < a.Length; i++) {
        if (a[i] == b[i]) similar++;
      }
      return similar / (double)a.Length;
    }

    public static double CalculateGenotypeDistance(IntegerVector a, IntegerVector b) {
      return 1.0 - CalculateGenotypeSimilarity(a, b);
    }
  }
}
